classification
Title: Visit the type of instance of heap types if tp_traverse is not implemented
Type: Stage: resolved
Components: C API, Interpreter Core Versions: Python 3.10, Python 3.9
process
Status: closed Resolution: duplicate
Dependencies: Superseder: [C API] Heap types (PyType_FromSpec) must fully implement the GC protocol
View: 42972
Assigned To: Nosy List: corona10, pablogsal, shihai1991, vstinner
Priority: normal Keywords: patch

Created on 2020-06-19 14:05 by vstinner, last changed 2021-01-19 21:55 by vstinner. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 20983 closed vstinner, 2020-06-19 14:13
Messages (3)
msg371884 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2020-06-19 14:05
While reviewing changes of bpo-40077 "Convert static types to PyType_FromSpec()", I noticed that some static types don't implement tp_traverse.

The doc says:

    Heap-allocated types (...) hold a reference to their type. Their traversal function must therefore either visit Py_TYPE(self), or delegate this responsibility by calling tp_traverse of another heap-allocated type (such as a heap-allocated superclass). If they do not, the type object may not be garbage-collected.

https://docs.python.org/dev/c-api/typeobj.html#c.PyTypeObject.tp_traverse

Porting to 3.9 says:

    for types that have a custom tp_traverse function, ensure that all custom tp_traverse functions of heap-allocated types visit the object’s type

https://docs.python.org/dev/whatsnew/3.9.html#changes-in-the-c-api

--

It seems like converting a static type to a heap allocated type requires to *add* a new tp_traverse function, if it wasn't the case.

Maybe we can provide a base tp_traverse implementation in the base object type: visit the type if it's a heap type?

See attached PR.

See bpo-35810 and bpo-40217 for more information.
msg384986 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2021-01-12 23:57
I created a thread on python-dev:
"Heap types (PyType_FromSpec) must fully implement the GC protocol"
https://mail.python.org/archives/list/python-dev@python.org/thread/C4ILXGPKBJQYUN5YDMTJOEOX7RHOD4S3/
msg385298 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2021-01-19 21:55
I created bpo-42972 instead.
History
Date User Action Args
2021-01-19 21:55:23vstinnersetstatus: open -> closed
superseder: [C API] Heap types (PyType_FromSpec) must fully implement the GC protocol
messages: + msg385298

resolution: duplicate
stage: patch review -> resolved
2021-01-12 23:57:54vstinnersetmessages: + msg384986
2020-06-19 15:44:52shihai1991setnosy: + shihai1991
2020-06-19 14:33:42corona10setnosy: + corona10
2020-06-19 14:13:52vstinnersetkeywords: + patch
stage: patch review
pull_requests: + pull_request20157
2020-06-19 14:05:01vstinnercreate